<template>
  <div id="all-invoice-table-container">
    <div v-if="showModal">
      <InvoiceLinesModal
        :invoiceLines="this.invoiceLines"
        @closed="modalClosed"
      />
    </div>
    <v-card>
      <v-card-title>
        Invoices Table
        <v-spacer></v-spacer>
        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Search"
          single-line
          hide-details
        ></v-text-field>
      </v-card-title>
    </v-card>
    <v-data-table
      :loading="loading"
      :search="search"
      :items="invoices"
      :headers="user.role == 'Admin' ? headersAdmin : headersTrainer"
      @click:row="getInvoiceLines"
    ></v-data-table>
  </div>
</template>

<script>
import invoice from "../../controllers/invoice.controller";
import swal from "sweetalert2";
export default {
  name: "InvoicesTable",
  props: ["user"],
  data: function () {
    return {
      loading: true,
      search: "",
      invoices: [],
      showModal: false,
      invoiceLines: [],
      headersAdmin: [
        { text: "Client Name", value: "clientName" },
        { text: "Issue Date", value: "issueDate" },
        { text: "Due Date", value: "dueDate" },
        { text: "Trainer Name", value: "trainerName" },
        { text: "Status", value: "status" },
      ],
      headersTrainer: [
        { text: "Client Name", value: "clientName" },
        { text: "Issue Date", value: "issueDate" },
        { text: "Due Date", value: "dueDate" },
        { text: "Status", value: "status" },
      ],
    };
  },
  methods: {
    async getInvoices() {
      this.loading = true;
      this.invoices = [];
      try {
        if (this.user.role === "Trainer") {
          this.invoices = await invoice.getTrainersInvoices(
            this.user.trainerId
          );
        } else {
          this.invoices = await invoice.getInvoices();
        }
        if (this.invoices.length > 0) {
          this.invoices.forEach((invoice) => {
            invoice.issueDate = invoice.issueDate.substring(0, 10);
            invoice.dueDate = invoice.dueDate.substring(0, 10);
            invoice.status =
              invoice.status == 0
                ? "Sent"
                : invoice.status == 1
                ? "Payed"
                : invoice.status == 2
                ? "Cancelled"
                : "Expired";
          });
        }
      } catch (e) {
        swal.fire("Something went wrong");
      }
      this.loading = false;
    },
    async getInvoiceLines(params) {
      this.invoiceLines = await invoice.getInvoiceLinesForInvoice(
        params.invoiceId
      );
      if (this.invoiceLines.length > 0) {
        const list = this.invoiceLines
          .map((line) => {
            return `<div style="display: flex; justify-content: space-evenly">
            <span>Price: ${line.price}</span>
            <span>Quantity: ${line.quantity}</span>
            <span>Total: ${line.quantity * line.price} </span>
            <span>Description: ${line.description}</span>

        </div>`;
          })
          .join("");

        swal.fire({
          html: list,
        });
      }
    },
  },
  async mounted() {
    this.getInvoices();
  },
};
</script>

<style scoped>
</style>